<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	boolean isAdmin = false;
	boolean isPatientCurator = false;
	boolean hasCreateSamplePermission = false;
	boolean hasCreateExtractPermission = false;
	try
	{
		Role admin = Role.getById(dc, SystemItems.getId(Role.ADMINISTRATOR));
		isAdmin = sc.isMemberOf(admin);
	}
	catch (RuntimeException ex)
	{}
	try
	{
		ItemQuery<Group> query = Group.getQuery();
		query.restrict(Restrictions.eq(Hql.property("name"), Expressions.string("PatientCurator")));
		List<Group> result = query.list(dc);
		if (result.size() == 1)
		{
			isPatientCurator = sc.isMemberOf(result.get(0));
		}
	}
	catch (RuntimeException ex)
	{}
	try
	{
		if (sc.hasPermission(Permission.CREATE, Item.SAMPLE))
		{
			hasCreateSamplePermission = true;
		}
	}
	catch(RuntimeException ex)
	{}
	try
	{
		if (sc.hasPermission(Permission.CREATE, Item.EXTRACT))
		{
			hasCreateExtractPermission = true;
		}
	}
	catch(RuntimeException ex)
	{}
%>
<base:page type="default" >
<base:head styles="path.css">
<style>
dd
{
	margin-left: 0px;
	margin-bottom: 10px;
}
</style>
</base:head>
<base:body>

	<p:path style="margin-top: 20px; margin-bottom: 10px;">
		<p:pathelement title="Reggie" />
	</p:path>

	<table border="0" cellspacing="0" cellpadding="0" width="100%" style="margin-left: 20px;">
	<tr valign="top">
		<td width="50%">
	
		<h3 class="light">Reggie wizards</h3>
		<div class="boxedbottom">
			<dl>
			
			<%
			if (isAdmin)
			{
				%>
				<dt>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td><base:icon image="configure.png" style="padding-right: 4px;"/></td>
						<td><a href="install.jsp?ID=<%=ID%>">Installation wizard</a></td>
					</tr>
					</table>
				</dt>
				<dd>
					<ul>
					<li>Check that all annotation types and other items used by Reggie exists in BASE.
					<li>Create missing items.
					</ul>
				</dd>
				<%
			}
			if (isPatientCurator || isAdmin)
			{
				%>
				<dt style="border-top: 1px solid #999999; padding-top: 4px;">
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td><base:icon image="share.gif" style="padding-right: 4px;"/></td>
						<td><a href="persinfo.jsp?ID=<%=ID%>">Personal information registration wizard</a></td>
					</tr>
					</table>
				</dt>
				<dd>
					<ul>
					<li>Register new cases and patients.
					<li>Update existing cases and specimen tubes.
					</ul>
				</dd>
				<%
			}
			if (isPatientCurator || isAdmin)
			{
				%>
				<dt>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td><base:icon image="<%=home + "/images/blood.png" %>" style="padding-right: 4px;"/></td>
						<td><a href="bloodform.jsp?ID=<%=ID%>">Blood referral form registration wizard</a></td>
					</tr>
					</table>
				</dt>
				<dd>
					<ul>
					<li>Register new blood referral forms and patients.
					<li>Update information for existing blood referral forms.
					</ul>
				</dd>
				<%
			}
			if (isPatientCurator || isAdmin)
			{
				%>
				<dt>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td><base:icon image="<%=home+"/images/consent.png" %>" style="padding-right: 4px;"/></td>
						<td><a href="consentform.jsp?ID=<%=ID%>">Consent form registration wizard</a></td>
					</tr>
					</table>
				</dt>
				<dd>
					<ul>
					<li>Register consent forms.
					</ul>
				</dd>
				<%
			}
			if (isPatientCurator || isAdmin)
			{
				%>
				<dt>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td><base:icon image="<%=home+"/images/pdffile.png" %>" style="padding-right: 4px;"/></td>
						<td><a href="refform.jsp?ID=<%=ID%>">Referral form registration wizard</a></td>
					</tr>
					</table>
				</dt>
				<dd>
					<ul>
					<li>Link scanned referral forms to cases.
					</ul>
				</dd>
				<%
			}
			if (hasCreateSamplePermission)
			{
				%>
				<dt style="border-top: 1px solid #999999; padding-top: 4px;">
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td><base:icon image="<%=home+"/images/specimen.png" %>" style="padding-right: 4px;"/></td>
						<td><a href="specimentube.jsp?ID=<%=ID%>">Specimen tube registration wizard</a></td>
					</tr>
					</table>
				</dt>
				<dd>
					<ul>
					<li>Register new specimen tubes.
					<li>Update existing specimen tubes.
					</ul>
				</dd>
				<%
			}
			if (hasCreateSamplePermission && hasCreateExtractPermission)
			{
				%>
				<dt>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td><base:icon image="<%=home+"/images/partition.png" %>" style="padding-right: 4px;"/></td>
						<td><a href="partitionform.jsp?ID=<%=ID%>">Partition registration wizard</a></td>
					</tr>
					</table>
				</dt>
				<dd>
					<ul>
					<li>Register new partitions of existing specimens.
					</ul>
				</dd>
				<%
			}			
			%>				
			</dl>
		</div>
		</td>
		<td width="50%">
		</td>
	</tr>
	</table>
	
	<table border="0" cellspacing="0" cellpadding="0" width="100%" style="margin-left: 20px;">
	<tr valign="top">
		<td width="50%">
	
		<h3 class="light">Reggie reports</h3>
		<div class="boxedbottom">
		<dl>
			<dt>
			<table border="0" cellspacing="0" cellpadding="0">
				<tr>
					<td><base:icon image="table.gif" style="padding-right: 4px;"/></td>
					<td><a href="samplereportgenerator.jsp?ID=<%=ID%>">Report generator</a></td>
				</tr>					
			</table>
			</dt>				
			<dd>				
				<ul>
				<li>Sample count report</li> 
				</ul>
			</dd>
		</dl>
		</div>
		</td>
		<td width="50%">
		</td>
	</tr>
	</table>	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>